%define baseversion 1.8.4
Name: gd
Version: 1.8.4ru
Release: alt2

Summary: A graphics library for drawing image files in various formats
License: BSD-style
Group: Graphics

Source: http://www.boutell.com/%name/%name-%baseversion.tar.bz2
Source1: gd-koi8-u.tar.bz2
Patch: %name-1.8.3-decls.patch

Prefix: %prefix

# Automatically added by buildreq on Wed Oct 10 2001
BuildRequires: freetype2-devel libjpeg-devel libpng-devel XFree86-devel zlib-devel

%package -n lib%name
Summary: A graphics library for drawing image files in various formats
Group: System/Libraries
Provides: %name = %version, %name-russian = %baseversion
Obsoletes: %name, %name-russian

%package -n lib%name-devel
Summary: The development libraries and header files for lib%name
Group: Development/C
Requires: lib%name = %version-%release
Provides: %name-devel = %version, %name-russian-devel = %baseversion
Obsoletes: %name-devel, %name-russian-devel

%package -n lib%name-devel-static
Summary: The development static library for lib%name
Group: Development/C
Requires: lib%name-devel = %version-%release

%package utils
Summary: The utilities for drawing image files in various formats
Group: Graphics
Requires: lib%name = %version-%release
Provides: %name-progs = %version, %name-utils = %version
Obsoletes: %name-utils, %name-progs

%description
Gd is a graphics library for drawing image files in various formats. Gd
allows your code to quickly draw images (lines, arcs, text, multiple colors,
cutting and pasting from other images, flood fills) and write out the result
as a jpeg, png or wbmp file. Gd is particularly useful in web applications,
where jpeg, png or wbmp files are commonly used as inline images.  Note,
however, that %name is not a paint program.

%description -n lib%name
Gd is a graphics library for drawing image files in various formats. Gd
allows your code to quickly draw images (lines, arcs, text, multiple colors,
cutting and pasting from other images, flood fills) and write out the result
as a jpeg, png or wbmp file. Gd is particularly useful in web applications,
where jpeg, png or wbmp files are commonly used as inline images.  Note,
however, that %name is not a paint program.

Install lib%name if you are using lib%name-based applications.

%description -n lib%name-devel
Gd is a graphics library for drawing image files in various formats. Gd
allows your code to quickly draw images (lines, arcs, text, multiple colors,
cutting and pasting from other images, flood fills) and write out the result
as a jpeg, png or wbmp file. Gd is particularly useful in web applications,
where jpeg, png or wbmp files are commonly used as inline images.  Note,
however, that %name is not a paint program.

Install lib%name-devel if you are developing applications which need to draw
image files in various formats.

%description -n lib%name-devel-static
Gd is a graphics library for drawing image files in various formats. Gd
allows your code to quickly draw images (lines, arcs, text, multiple colors,
cutting and pasting from other images, flood fills) and write out the result
as a jpeg, png or wbmp file. Gd is particularly useful in web applications,
where jpeg, png or wbmp files are commonly used as inline images.  Note,
however, that %name is not a paint program.

Install lib%name-devel-static if you are developing statically linked
applications which need to draw image files in various formats.

%description utils
Gd is a graphics library for drawing image files in various formats. Gd
allows your code to quickly draw images (lines, arcs, text, multiple colors,
cutting and pasting from other images, flood fills) and write out the result
as a jpeg, png or wbmp file. Gd is particularly useful in web applications,
where jpeg, png or wbmp files are commonly used as inline images.  Note,
however, that %name is not a paint program.

Gd is not a paint program. If you are looking for a paint program,
you are looking in the wrong place. If you are not a programmer, you
are looking in the wrong place.

Gd does not provide for every possible desirable graphics operation.
It is not necessary or desirable for %name to become a kitchen-sink
graphics package, but version %version incorporates most of the commonly
requested features for an 8-bit 2D package. Support for truecolor
images, JPEG and truecolor PNG is planned for version 2.0.

%prep
%setup -q -a1 -n%name-%baseversion
%patch -p1

# KOI8-U fonts
rm -f gdfont*.[ch]
chmod 755 bdftogd
cat 5x8-koi8-u.bdf | ./bdftogd FontTiny	gdfontt
cat 6x13-koi8-u.bdf | ./bdftogd FontSmall gdfonts
cat 7x13B-koi8-u.bdf | ./bdftogd FontMediumBold gdfontmb
cat 8x16-koi8-u.bdf | ./bdftogd FontLarge gdfontl
cat 9x15B-koi8-u.bdf | ./bdftogd FontGiant gdfontg

%build
%define	_optlevel 9
%add_optflags -DHAVE_LIBXPM -DHAVE_LIBPNG -DHAVE_LIBJPEG -DHAVE_LIBFREETYPE -I/usr/include/freetype2 -I/usr/include/X11
%define major %(echo %baseversion |cut -d. -f1)

# First, build shared library.
%make_build lib%name.a \
	CFLAGS="$RPM_OPT_FLAGS %optflags_shared" \
	LIBS="-lm -lz -lpng -ljpeg -lfreetype" \
	INCLUDEDIRS=-I. \
	LIBDIRS=-L.

gcc -shared -o lib%name.so.%baseversion -Wl,-soname=lib%name.so.%major \
        `ar t lib%name.a` -L/usr/X11R6/lib -lm -lz -lpng -ljpeg -lfreetype

# Second, build static library.
rm -f *.o *.a
%make_build lib%name.a \
	CFLAGS="$RPM_OPT_FLAGS" \
	LIBS="-lm -lz -lpng -ljpeg -lfreetype" \
	INCLUDEDIRS=-I. \
	LIBDIRS=-L.
mv -f lib%name.a lib%name.a~

# Third, build utils.
rm -f *.o *.a
make \
	CFLAGS="$RPM_OPT_FLAGS %optflags_notraceback" \
	LIBS="-lm -lz -lpng -ljpeg -lfreetype -l%name" \
	INCLUDEDIRS=-I. \
	LIBDIRS=-L.

touch -r lib%name.a lib%name.a~
mv -f lib%name.a~ lib%name.a

%install
mkdir -p $RPM_BUILD_ROOT{%_bindir,%_libdir,%_includedir}
%make_install install \
	INSTALL_BIN=$RPM_BUILD_ROOT%_bindir \
	INSTALL_LIB=$RPM_BUILD_ROOT%_libdir \
	INSTALL_INCLUDE=$RPM_BUILD_ROOT%_includedir
install -p -m755 lib%name.so.%baseversion $RPM_BUILD_ROOT%_libdir
ln -s lib%name.so.%baseversion $RPM_BUILD_ROOT%_libdir/lib%name.so

bzip2 -9 *.txt

%post -n lib%name -p /sbin/ldconfig
%postun -n lib%name -p /sbin/ldconfig

%files -n lib%name
%_libdir/*.so.*

%files -n lib%name-devel
%_libdir/*.so
%_includedir/*
%doc *.bz2 index.html

%files -n lib%name-devel-static
%_libdir/*.a

%files utils
%_bindir/*

%changelog
* Mon Nov 9 2001 DH <dh@dh.net.ru> 1.8.4ru-alt2
- First Release with build-in KOI8-U fonts by   <smile@aval.kiev.ua>
